SystemOrganization addCategory: #'CAP-Proves'!

Object subclass: #Pasta
	instanceVariableNames: 'moneda quantitat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAP-Proves'!

!Pasta class methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:17'!
moneda: unString quantitat: unNombre

	^ self new moneda: unString; quantitat: unNombre! !

!Pasta methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:18'!
+ unaPasta

	(self moneda = unaPasta moneda)
		ifTrue: [^ Pasta moneda: self moneda quantitat: (self quantitat + unaPasta quantitat)] 
		ifFalse: [self error: 'No es poden sumar monedes diferents']! !

!Pasta methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:10'!
= unaPasta

	^ self moneda = unaPasta moneda and: [self quantitat = unaPasta quantitat]! !

!Pasta methodsFor: 'accessing' stamp: 'NatxoRaga 11/4/2012 19:04'!
moneda
	
	^ moneda! !

!Pasta methodsFor: 'accessing' stamp: 'NatxoRaga 11/4/2012 19:04'!
moneda: anObject
	
	moneda := anObject! !

!Pasta methodsFor: 'accessing' stamp: 'NatxoRaga 11/4/2012 19:04'!
quantitat
	
	^ quantitat! !

!Pasta methodsFor: 'accessing' stamp: 'NatxoRaga 11/4/2012 19:04'!
quantitat: anObject
	
	quantitat := anObject! !

!Integer methodsFor: '*CAP-Proves' stamp: 'NatxoRaga 11/4/2012 19:20'!
euro

	^ Pasta moneda: 'EUR' quantitat: self! !

TestCase subclass: #PastaTest
	instanceVariableNames: 'eur5 eur10 eur20'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAP-Proves'!

PastaTest class
	instanceVariableNames: 'setUp'!

PastaTest class
	instanceVariableNames: 'setUp'!

!PastaTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:21'!
setUp
	"initialize PastaTest instance variables"
	
	eur5 := 5 euro.
	eur10 := 10 euro.
	eur20 := 20 euro.
	! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:18'!
testIguals

	self assert: eur5 = eur5.
	self assert: eur5 = (Pasta moneda: 'EUR' quantitat: 5).
	self assert: eur5 ~= eur10. ! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/4/2012 19:16'!
testSuma

	self assert: eur5 + eur5 = eur10.
	self assert: eur10 + eur10 = eur20.
	self assert: eur20 = (eur5 + eur5 + eur5 + eur5)! !
